<?php
/**
 * Clase Base FN para BaseRhMarcacionDetalleFN
 *
 * @package    
 * @subpackage BaseRhMarcacionDetalleFN
 * @author     Willy
 * @version    SVN:: BaseRhMarcacionDetalleFN.class.php,v 1.1 2019-04-30 11:03:20 william.taype Exp $
 */
class BaseRhMarcacionDetalleFN extends RhMarcacionDetalleBN
{
  private static $fieldNames = array (
    'Iddetalle'=>'iddetalle', 'Idmarcacion'=>'idmarcacion', 'Descripcion'=>'descripcion', 'Flagtienedescuento'=>'flagtienedescuento', 'Secuencia'=>'secuencia'  
  );

  public function select()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT iddetalle, idmarcacion, descripcion, flagtienedescuento, secuencia FROM rh_marcacion_detalle WHERE 1 ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT iddetalle, idmarcacion, descripcion, flagtienedescuento, secuencia FROM rh_marcacion_detalle WHERE 1 ".$where;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getIddetalle()){ $where .= " AND iddetalle = '".$this->getIddetalle()."'"; }
      if($this->getIdmarcacion()){ $where .= " AND idmarcacion = '".$this->getIdmarcacion()."'"; }
      if($this->getDescripcion()){ $where .= " AND descripcion = '".$this->getDescripcion()."'"; }
      if($this->getFlagtienedescuento()){ $where .= " AND flagtienedescuento = '".$this->getFlagtienedescuento()."'"; }
      if($this->getSecuencia()){ $where .= " AND secuencia = '".$this->getSecuencia()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Búsqueda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT iddetalle, idmarcacion, descripcion, flagtienedescuento, secuencia FROM rh_marcacion_detalle WHERE 1 AND iddetalle='".$this->getIddetalle()."' AND idmarcacion='".$this->getIdmarcacion()."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con métodos de acceso */
  private function insertObjectBN($o_propel){
    $o_BaseRhMarcacionDetalleFN = new BaseRhMarcacionDetalleFN();
    $o_BaseRhMarcacionDetalleFN->setIddetalle($o_propel->iddetalle);
    $o_BaseRhMarcacionDetalleFN->setIdmarcacion($o_propel->idmarcacion);
    $o_BaseRhMarcacionDetalleFN->setDescripcion($o_propel->descripcion);
    $o_BaseRhMarcacionDetalleFN->setFlagtienedescuento($o_propel->flagtienedescuento);
    $o_BaseRhMarcacionDetalleFN->setSecuencia($o_propel->secuencia);
    return $o_BaseRhMarcacionDetalleFN;
  }
}